## readpe 0.82

=== Makefile ===
LIBPE_DIR = lib/libpe
PEV_DIR = src
VERSION = 0.82
ZIPDIR = pev-$(VERSION)-win
ZIPFILE = $(ZIPDIR).zip

all:
%:
	cd $(LIBPE_DIR) && $(MAKE) $@
	cd $(PEV_DIR) && $(MAKE) $@

# Cygwin only
zip:
	cd $(PEV_DIR)/windows && $(MAKE)
	mkdir -p $(ZIPDIR)/plugins
	cp src/build/plugins/*.dll $(ZIPDIR)/plugins/
	echo -ne "plugins_dir=plugins\r\n" > $(ZIPDIR)/pev.conf
	cp $(PEV_DIR)/userdb.txt $(ZIPDIR)
	cp lib/libpe/libpe.dll $(ZIPDIR)/
	cp /usr/bin/cygwin1.dll $(ZIPDIR)/
	cp /usr/bin/cygcrypto-1*.dll $(ZIPDIR)/
	cp /usr/bin/cygz.dll $(ZIPDIR)/
	cp README.md $(ZIPDIR)/
	cp $(PEV_DIR)/build/*.exe $(ZIPDIR)/
	cp $(PEV_DIR)/windows/run.bat $(ZIPDIR)/
	zip -r $(ZIPFILE) $(ZIPDIR)/*
	rm -rf $(ZIPDIR)

=== src/Makefile ===
####### Platform specifics

# cut is necessary for Cygwin
export PLATFORM_OS := $(shell uname | cut -d_ -f1)

####### Makefile Conventions - Directory variables

srcdir = .
prefix = /usr/local

exec_prefix = $(prefix)
sysconfdir = $(prefix)/etc
includedir = $(prefix)/include
datarootdir = $(prefix)/share
localstatedir = $(prefix)/var

bindir = $(exec_prefix)/bin
libdir = $(exec_prefix)/lib
libexecdir = $(exec_prefix)/libexec
sbindir = $(exec_prefix)/sbin

datadir = $(datarootdir)
docdir = $(datarootdir)/doc/pev
infodir = $(datarootdir)/info
localedir = $(datarootdir)/locale

mandir = $(datarootdir)/man
manext = .1
man1dir = $(mandir)/man1
man1ext = .1

export pluginsdir = $(libdir)/pev/plugins

####### Makefile Conventions - Utilities

export CC ?= gcc
export LINK = $(CC)
export CHK_DIR_EXISTS = test -d
export CHK_FILE_EXISTS = test -f
export INSTALL = install
export INSTALL_DATA = ${INSTALL} -m 644
export INSTALL_PROGRAM = ${INSTALL}
export SYMLINK = ln -sf
export MKDIR = mkdir -p
export RM = rm -f
export RM_DIR = rm -rf
ifeq ($(PLATFORM_OS), Darwin)
	export STRIP = strip -x
else
	export STRIP = strip --strip-unneeded
endif

####### Compiler options

override LDFLAGS += -L$(LIBPE) -lpe -lcrypto -lssl -ldl -lm
override CFLAGS += -O2 -ffast-math -I$(LIBPE)/include -I"../include" -W -Wall -Wextra -Wno-implicit-fallthrough -std=c99 -pedantic

# To compile for production define the symbol NDEBUG before invoking this makefile.
override CPPFLAGS += \
	-D_GNU_SOURCE \
	-DSHAREDIR="\"$(SHAREDIR)"\" \
	-DPLUGINSDIR="\"$(pluginsdir)"\"

# Some gcc/clang builds (depends on the distro) already define _FORTIFY_SOURCE internally, so we
# only define it if it has not been already. This avoids redefinition warnings and weakening
# those distros' hardening settings.
ifneq ($(findstring _FORTIFY_SOURCE, $(CPPFLAGS)), _FORTIFY_SOURCE)
        override CPPFLAGS += -D_FORTIFY_SOURCE=1
endif

ifeq ($(PLATFORM_OS), Darwin)
	# We disable warnings for deprecated declarations since Apple deprecated OpenSSL in Mac OS X 10.7
	override CFLAGS += -Wno-deprecated-declarations
endif

ifeq ($(PLATFORM_OS), CYGWIN)
	override CPPFLAGS += -D_XOPEN_SOURCE=600
endif

SRC_DIRS = $(srcdir) $(srcdir)/compat

PROGS = readpe rva2ofs ofs2rva pehash pesec pescan pepack pestr pedis peres peldd
PLUGINS_DIR = $(srcdir)/plugins
SHAREDIR = $(datadir)/pev
export LIBPE = $(realpath $(srcdir)/../lib/libpe)
LIBUDIS86 = $(srcdir)/../lib/libudis86
MANDIR = $(srcdir)/../doc/manpages

export pev_BUILDDIR = ./build
pev_SRCS_FILTER = $(sort $(wildcard ${dir}/*.c))
pev_SRCS = $(foreach dir, ${SRC_DIRS}, ${pev_SRCS_FILTER})
pev_OBJS = $(addprefix ${pev_BUILDDIR}/, $(addsuffix .o, $(basename ${pev_SRCS})))

pev_COMMON_DEPS = \
	$(pev_BUILDDIR)/compat/strlcat.o \
	$(pev_BUILDDIR)/config.o \
	$(pev_BUILDDIR)/dylib.o \
	$(pev_BUILDDIR)/malloc_s.o \
	$(pev_BUILDDIR)/plugins.o \
	$(pev_BUILDDIR)/output_plugin.o \
	$(pev_BUILDDIR)/output.o \
	$(pev_BUILDDIR)/pev_api.o

####### Build rules

.PHONY: plugins install installdirs uninstall clean

all: $(PROGS) plugins

plugins:
	cd $(PLUGINS_DIR) && $(MAKE) $@

ofs2rva: $(pev_BUILDDIR)/ofs2rva.o $(pev_OBJS)
	$(CC) $< -o $(pev_BUILDDIR)/$@ $(pev_COMMON_DEPS) $(LDFLAGS)

pedis: CPPFLAGS += -DHAVE_STRING_H
pedis: CFLAGS += -I$(LIBUDIS86)
pedis: $(pev_BUILDDIR)/pedis.o $(pev_OBJS)
	$(CC) $< -o $(pev_BUILDDIR)/$@ $(pev_COMMON_DEPS) $(LDFLAGS) $(CFLAGS) $(CPPFLAGS) $(sort $(LIBUDIS86)/libudis86/*.c)

pehash: $(pev_BUILDDIR)/pehash.o $(pev_OBJS)
	$(CC) $< -o $(pev_BUILDDIR)/$@ $(pev_COMMON_DEPS) $(LDFLAGS) $(CFLAGS) $(CPPFLAGS)

pepack: $(pev_BUILDDIR)/pepack.o $(pev_OBJS)
	$(CC) $< -o $(pev_BUILDDIR)/$@ $(pev_COMMON_DEPS) $(LDFLAGS) $(CFLAGS) $(CPPFLAGS)

peres: $(pev_BUILDDIR)/peres.o $(pev_OBJS)
	$(CC) $< -o $(pev_BUILDDIR)/$@ $(pev_COMMON_DEPS) $(LDFLAGS) $(CFLAGS) $(CPPFLAGS)

pescan: LDFLAGS += -lm
pescan: $(pev_BUILDDIR)/pescan.o $(pev_OBJS)
	$(CC) $< -o $(pev_BUILDDIR)/$@ $(pev_COMMON_DEPS) $(LDFLAGS) $(CFLAGS) $(CPPFLAGS)

pesec: LDFLAGS += -lcrypto
pesec: $(pev_BUILDDIR)/pesec.o $(pev_OBJS)
	$(CC) $< -o $(pev_BUILDDIR)/$@ $(pev_COMMON_DEPS) $(LDFLAGS) $(CFLAGS) $(CPPFLAGS)

pestr: $(pev_BUILDDIR)/pestr.o $(pev_OBJS)
	$(CC) $< -o $(pev_BUILDDIR)/$@ $(pev_COMMON_DEPS) $(LDFLAGS) $(CFLAGS) $(CPPFLAGS)

readpe: $(pev_BUILDDIR)/readpe.o $(pev_OBJS)
	$(CC) $< -o $(pev_BUILDDIR)/$@ $(pev_COMMON_DEPS) $(LDFLAGS) $(CFLAGS) $(CPPFLAGS)

rva2ofs: $(pev_BUILDDIR)/rva2ofs.o $(pev_OBJS)
	$(CC) $< -o $(pev_BUILDDIR)/$@ $(pev_COMMON_DEPS) $(LDFLAGS) $(CFLAGS) $(CPPFLAGS)
	
peldd: $(pev_BUILDDIR)/peldd.o $(pev_OBJS)
	$(CC) $< -o $(pev_BUILDDIR)/$@ $(pev_COMMON_DEPS) $(LDFLAGS) $(CFLAGS) $(CPPFLAGS)

# Generic rule matching sources

$(pev_BUILDDIR)/%.o: %.c
	@$(CHK_DIR_EXISTS) $(dir $@) || $(MKDIR) $(dir $@)
	$(CC) -c -o $@ $< $(CFLAGS) $(CPPFLAGS) $(INCPATH)

install: installdirs
	for prog in $(PROGS); do \
		$(INSTALL_PROGRAM) $(INSTALL_FLAGS) $(pev_BUILDDIR)/$$prog $(DESTDIR)$(bindir); \
		$(CHK_FILE_EXISTS) $(MANDIR)/$$prog$(man1ext) && \
			gzip -c -9 $(MANDIR)/$$prog$(man1ext) > $(DESTDIR)$(man1dir)/$$prog$(man1ext).gz || \
			echo -n; \
	done

	$(INSTALL_DATA) $(srcdir)/userdb.txt $(DESTDIR)$(SHAREDIR)
	cd $(PLUGINS_DIR) && $(MAKE) $@

install-strip: INSTALL_FLAGS += -s
install-strip: install

installdirs:
	@$(CHK_DIR_EXISTS) $(DESTDIR) || $(MKDIR) $(DESTDIR)
	@$(CHK_DIR_EXISTS) $(DESTDIR)$(bindir) || $(MKDIR) $(DESTDIR)$(bindir)
	@$(CHK_DIR_EXISTS) $(DESTDIR)$(man1dir) || $(MKDIR) $(DESTDIR)$(man1dir)
	@$(CHK_DIR_EXISTS) $(DESTDIR)$(SHAREDIR) || $(MKDIR) $(DESTDIR)$(SHAREDIR)

uninstall:
	for prog in $(PROGS); do \
		$(RM) $(DESTDIR)$(bindir)/$$prog; \
		$(RM) $(DESTDIR)$(man1dir)/$$prog$(man1ext).gz; \
	done
	$(RM_DIR) $(DESTDIR)$(SHAREDIR)
	cd $(PLUGINS_DIR) && $(MAKE) $@

clean:
	$(RM_DIR) $(pev_BUILDDIR)
	$(RM) $(PROGS)
	cd $(PLUGINS_DIR) && $(MAKE) $@

=== lib/libpe/Makefile ===
####### Platform specifics

# cut is necessary for Cygwin
PLATFORM_OS := $(shell uname | cut -d_ -f1)

####### Makefile Conventions - Directory variables

srcdir = .
prefix = /usr/local
exec_prefix = $(prefix)
sysconfdir = $(prefix)/etc
includedir = $(prefix)/include
datarootdir = $(prefix)/share
localstatedir = $(prefix)/var
bindir = $(exec_prefix)/bin
libdir = $(exec_prefix)/lib
libexecdir = $(exec_prefix)/libexec
sbindir = $(exec_prefix)/sbin
datadir = $(datarootdir)
docdir = $(datarootdir)/doc/pev
infodir = $(datarootdir)/info
localedir = $(datarootdir)/locale

mandir = $(datarootdir)/man
manext = .1
man1dir = $(mandir)/man1
man1ext = .1

####### Makefile Conventions - Utilities

CC ?= gcc
LINK = $(CC)
CHK_DIR_EXISTS = test -d
CHK_FILE_EXISTS = test -f
INSTALL = install
INSTALL_DATA = ${INSTALL} -m 644
INSTALL_PROGRAM = $(INSTALL)
SYMLINK = ln -sf
MKDIR = mkdir -p
RM = rm -f
RM_DIR = rm -rf

ifeq ($(PLATFORM_OS), Darwin)
	STRIP = strip -x
else
	STRIP = strip --strip-unneeded
endif

####### Compiler options

override CFLAGS += \
	-O2 -ffast-math \
	-I"./include" \
	-fPIC \
	-W -Wall -Wextra -pedantic -std=c99 -c
override CPPFLAGS += -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2
#override LDFLAGS += -lssl -lcrypto
LIBS = -lssl -lcrypto

# --- FIX: -fPIC is necessary to ALL shared objects! Changed above.
#ifneq ($(PLATFORM_OS), CYGWIN)
#	override CFLAGS += -fPIC
#endif

VERSION = 0.82
LIBNAME = libpe

SRC_DIRS = $(srcdir) $(srcdir)/libfuzzy

libpe_BUILDDIR = $(CURDIR)/build
libpe_SRCS_FILTER = $(sort $(wildcard ${dir}/*.c))
libpe_SRCS = $(foreach dir, ${SRC_DIRS}, ${libpe_SRCS_FILTER})
libpe_OBJS = $(addprefix ${libpe_BUILDDIR}/, $(addsuffix .o, $(basename ${libpe_SRCS})))

####### Build rules

.PHONY : libpe install strip-binaries install-strip uninstall clean

all: libpe

# FIX: WARNING.. ld expects -l option at the END of the command line or after the object files.
#      From gcc's documentation:
#
# It makes a difference where in the command you write this option; the linker searches and processes
# libraries and object files in the order they are specified. Thus, ‘foo.o -lz bar.o’ searches library
# ‘z’ after file foo.o but before bar.o. If bar.o refers to functions in ‘z’, those functions 
# may not be loaded.
#

libpe: CPPFLAGS += -D_GNU_SOURCE
ifeq ($(PLATFORM_OS), CYGWIN)
libpe: CPPFLAGS += -D_XOPEN_SOURCE=600
endif
libpe: $(libpe_OBJS)
ifeq ($(PLATFORM_OS), Linux)
	$(LINK) -shared -Wl,-soname,$(LIBNAME).so.1 $(LDFLAGS) -o $(LIBNAME).so $^ $(LIBS)
else ifeq ($(PLATFORM_OS), NetBSD)
	$(LINK) -shared -Wl,-soname,$(LIBNAME).so.1 $(LDFLAGS) -o $(LIBNAME).so $^ $(LIBS)
else ifeq ($(PLATFORM_OS), FreeBSD)
	$(LINK) -shared -Wl,-soname,$(LIBNAME).so.1 $(LDFLAGS) -o $(LIBNAME).so $^ $(LIBS)
else ifeq ($(PLATFORM_OS), OpenBSD)
	$(LINK) -shared -Wl,-soname,$(LIBNAME).so.1 $(LDFLAGS) -o $(LIBNAME).so $^ $(LIBS)
else ifeq ($(PLATFORM_OS), GNU)
	$(LINK) -shared -Wl,-soname,$(LIBNAME).so.1 $(LDFLAGS) -o $(LIBNAME).so $^ $(LIBS)
else ifeq ($(PLATFORM_OS), GNU/kFreeBSD)
	$(LINK) -shared -Wl,-soname,$(LIBNAME).so.1 $(LDFLAGS) -o $(LIBNAME).so $^ $(LIBS)
else ifeq ($(PLATFORM_OS), Darwin)
	$(LINK) -headerpad_max_install_names -dynamiclib \
		-flat_namespace -install_name $(LIBNAME).$(VERSION).dylib \
		-current_version $(VERSION) -compatibility_version $(VERSION) \
		$(LDFLAGS) -o $(LIBNAME).dylib $^ $(LIBS)
else ifeq ($(PLATFORM_OS), CYGWIN)
	$(LINK) -shared -o $(LIBNAME).dll $^ $(LDFLAGS) $(LIBS)
endif

$(libpe_BUILDDIR)/%.o: %.c
	@$(CHK_DIR_EXISTS) $(dir $@) || $(MKDIR) $(dir $@)
	$(CC) -c $(CFLAGS) $(CPPFLAGS) -o $@ $<

install: installdirs
ifeq ($(PLATFORM_OS), Linux)
	$(INSTALL_DATA) $(INSTALL_FLAGS) $(LIBNAME).so $(DESTDIR)$(libdir)/$(LIBNAME).so.$(VERSION)
	cd $(DESTDIR)$(libdir); $(SYMLINK) $(LIBNAME).so.$(VERSION) $(LIBNAME).so
	cd $(DESTDIR)$(libdir); $(SYMLINK) $(LIBNAME).so.$(VERSION) $(LIBNAME).so.1
else ifeq ($(PLATFORM_OS), NetBSD)
	$(INSTALL_DATA) $(INSTALL_FLAGS) $(LIBNAME).so $(DESTDIR)$(libdir)/$(LIBNAME).so.$(VERSION)
	cd $(DESTDIR)$(libdir); $(SYMLINK) $(LIBNAME).so.$(VERSION) $(LIBNAME).so
	cd $(DESTDIR)$(libdir); $(SYMLINK) $(LIBNAME).so.$(VERSION) $(LIBNAME).so.1
else ifeq ($(PLATFORM_OS), FreeBSD)
	$(INSTALL_DATA) $(INSTALL_FLAGS) $(LIBNAME).so $(DESTDIR)$(libdir)/$(LIBNAME).so.$(VERSION)
	cd $(DESTDIR)$(libdir); $(SYMLINK) $(LIBNAME).so.$(VERSION) $(LIBNAME).so
	cd $(DESTDIR)$(libdir); $(SYMLINK) $(LIBNAME).so.$(VERSION) $(LIBNAME).so.1
else ifeq ($(PLATFORM_OS), OpenBSD)
	$(INSTALL_DATA) $(INSTALL_FLAGS) $(LIBNAME).so $(DESTDIR)$(libdir)/$(LIBNAME).so.$(VERSION)
	cd $(DESTDIR)$(libdir); $(SYMLINK) $(LIBNAME).so.$(VERSION) $(LIBNAME).so
	cd $(DESTDIR)$(libdir); $(SYMLINK) $(LIBNAME).so.$(VERSION) $(LIBNAME).so.1
else ifeq ($(PLATFORM_OS), GNU)
	$(INSTALL_DATA) $(INSTALL_FLAGS) $(LIBNAME).so $(DESTDIR)$(libdir)/$(LIBNAME).so.$(VERSION)
	cd $(DESTDIR)$(libdir); $(SYMLINK) $(LIBNAME).so.$(VERSION) $(LIBNAME).so
	cd $(DESTDIR)$(libdir); $(SYMLINK) $(LIBNAME).so.$(VERSION) $(LIBNAME).so.1
else ifeq ($(PLATFORM_OS), GNU/kFreeBSD)
	$(INSTALL_DATA) $(INSTALL_FLAGS) $(LIBNAME).so $(DESTDIR)$(libdir)/$(LIBNAME).so.$(VERSION)
	cd $(DESTDIR)$(libdir); $(SYMLINK) $(LIBNAME).so.$(VERSION) $(LIBNAME).so
	cd $(DESTDIR)$(libdir); $(SYMLINK) $(LIBNAME).so.$(VERSION) $(LIBNAME).so.1
else ifeq ($(PLATFORM_OS), Darwin)
	$(INSTALL_DATA) $(INSTALL_FLAGS) $(LIBNAME).dylib $(DESTDIR)$(libdir)/$(LIBNAME).$(VERSION).dylib
	cd $(DESTDIR)$(libdir); $(SYMLINK) $(LIBNAME).$(VERSION).dylib $(LIBNAME).dylib
	cd $(DESTDIR)$(libdir); $(SYMLINK) $(LIBNAME).$(VERSION).dylib $(LIBNAME).1.dylib
else ifeq ($(PLATFORM_OS), CYGWIN)
	# TODO
endif

installdirs:
	@$(CHK_DIR_EXISTS) $(DESTDIR) || $(MKDIR) $(DESTDIR)
	@$(CHK_DIR_EXISTS) $(DESTDIR)$(libdir) || $(MKDIR) $(DESTDIR)$(libdir)

install-strip: INSTALL_FLAGS += -s
install-strip: install

uninstall:
	$(RM) $(DESTDIR)$(libdir)/$(LIBNAME).so* \
		$(DESTDIR)$(libdir)/$(LIBNAME)*.dylib

clean:
	$(RM_DIR) $(libpe_BUILDDIR)
	$(RM) $(LIBNAME)*.o \
		$(LIBNAME)*.so \
		$(LIBNAME)*.dylib \
		$(LIBNAME)*.dll

=== debian/changelog ===
readpe (0.82-3.1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:54:38 +1100

readpe (0.82-3.1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 21:11:07 +0000

readpe (0.82-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063185

 -- Benjamin Drung <bdrung@debian.org>  Fri, 01 Mar 2024 12:44:00 +0000

readpe (0.82-3) unstable; urgency=medium

  * debian/tests/control:
      - Added 'Architecture' field to mark architectures on which tests are
        known not to work.
      - Added comment to clarify why the tests fail on two architectures.
      - Replaced '@' with 'readpe' on 'Depends' field to avoid testing
        transitional package 'pev'.

 -- David da Silva Polverari <polverari@debian.org>  Fri, 08 Sep 2023 22:48:02 +0000

readpe (0.82-2) unstable; urgency=medium

  * Upload to unstable.

 -- David da Silva Polverari <polverari@debian.org>  Mon, 04 Sep 2023 15:11:40 +0000

readpe (0.82-1) experimental; urgency=medium

  * New upstream release.
  * Upstream renamed the source from pev to readpe. Consequently:
      - debian/control:
          ~ Added readpe package stanza.
          ~ Changed Source field to readpe.
          ~ Made pev a transitional package.
          ~ Updated Homepage field.
          ~ Updated Vcs-* fields.
      - debian/copyright:
          ~ Added Comment field to header stanza.
          ~ Updated all previous header stanza fields.
      - debian/upstream/metadata: updated all existing fields.
      - debian/watch: updated to reflect upstream repository change.
  * Split package into multiple binaries. Consequently:
      - debian/control:
          ~ Added dh-exec to Build-Depends.
          ~ Added libpe1 and libpe1-dev package stanzas.
      - debian/libpe1.install: created to install libpe library files.
      - debian/libpe1.symbols: created to provide a symbols file to libpe1.
      - debian/libpe-dev.install: created to install libpe development files.
      - debian/lintian-overrides: removed.
      - debian/pev.dirs: removed in favor of debian/readpe.dirs.
      - debian/readpe.dirs: added to create directories for readpe installation.
      - debian/readpe.install: created to install readpe files.
      - debian/readpe.lintian-overrides: created to add an override due to bug
        #204975 and to accommodate previous override of false-positive lintian
        on documentation outside /usr/share/doc.
      - debian/rules: updated DESTDIR to reflect changes to installation
        directory.
      - debian/source/lintian-overrides: changed the source package name on
        lintian to match the new name.
  * debian/control:
      - Added myself to Uploaders.
      - Update team maintainer address to Debian Security Tools
        <team+pkg-security@tracker.debian.org>.
  * debian/copyright:
      - Removed superfluous Files pattern.
      - Reordered stand-alone License stanzas to match their appearance order.
      - Updated upstream copyright years.
  * debian/patches/: dropped, as all previous patches were merged upstream.
    Thanks!
  * debian/rules: replaced existing override_dh_auto_clean target with a an
    equivalent execute_after_dh_auto_clean target.

 -- David da Silva Polverari <polverari@debian.org>  Wed, 02 Aug 2023 17:22:08 -0300

pev (0.81-10) unstable; urgency=medium

  * debian/patches/:
      - 0001-widechar-off-by-one.patch: fixed DEP-3 patch metadata.
      - 0004-avoid-fixed-path.patch: updated patch metadata.
      - 0005-fix-ftbs-hurd-kfreebsd.patch: updated patch metadata.
  * debian/tests/test-runs: replaced confusing comments in autopkgtests. Thanks
    to Sam Hartman <hartmans@debian.org>. (Closes: #1040436)

 -- David da Silva Polverari <david.polverari@gmail.com>  Sun, 09 Jul 2023 01:08:02 -0300

pev (0.81-9) unstable; urgency=medium

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Update standards version to 4.6.2, no changes needed.

  [ David da Silva Polverari ]
  * debian/copyright: updated packaging copyright years.
  * debian/patches/0006-fix-bo-pe_exports.patch: created to fix a buffer
    overflow vulnerability present on libpe's pe_exports function
    (CVE-2021-45423). (Closes: #1034725)

 -- David da Silva Polverari <david.polverari@gmail.com>  Sat, 22 Apr 2023 19:41:47 +0000

pev (0.81-8) unstable; urgency=medium

  * debian/control: bumped Standards-Version to 4.6.1.
  * debian/lintian-overrides: modified existing overrides to comply with latest
    lintian output changes.
  * debian/rules: included /usr/share/dpkg/buildtools.mk back to set CC properly
    for cross-compilation and exported CC for usage by make, as dh_auto_build
    alone did not automatically pass cross tools as command variables to it.
  * debian/source/lintian-overrides: created to override false-positives.

 -- David da Silva Polverari <david.polverari@gmail.com>  Mon, 07 Nov 2022 17:46:55 +0000

pev (0.81-7) unstable; urgency=medium

  * debian/copyright: updated packaging copyright years.
  * debian/patches/0005-fix-ftbs-hurd-kfreebsd.patch: added to fix FTBFS on
    Debian GNU/Hurd and Debian GNU/kFreeBSD.

 -- David da Silva Polverari <david.polverari@gmail.com>  Tue, 08 Feb 2022 23:12:08 +0000

pev (0.81-6) unstable; urgency=medium

  * debian/control: bumped Standards-Version to 4.6.0.
  * debian/patches/0004-avoid-fixed-path.patch: added to fix FTBFS on Hurd and
    kFreeBSD due to unconditional PATH_MAX usage.
  * debian/rules: used a simpler approach to avoid FTCBFS. Thanks to Helmut
    Grohne <helmut@subdivi.de>. (Closes: #993122)

 -- David da Silva Polverari <david.polverari@gmail.com>  Tue, 01 Feb 2022 00:29:16 +0000

pev (0.81-5) unstable; urgency=medium

  * New maintainer. (Closes: #836368)
  * Ran wrap-and-sort.
  * Using new DH level format. Consequently:


=== debian/control ===
Source: readpe
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: David da Silva Polverari <polverari@debian.org>
Homepage: https://github.com/mentebinaria/readpe/wiki
Section: utils
Priority: optional
Standards-Version: 4.6.2
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), dh-exec, libssl-dev
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/pkg-security-team/readpe
Vcs-Git: https://salsa.debian.org/pkg-security-team/readpe.git

Package: pev
Depends: readpe, ${misc:Depends}
Architecture: all
Section: oldlibs
Description: text-based tool to analyze PE files (transitional package)
 pev is a tool to get information of PE32/PE32+ executables (EXE, DLL, OCX etc)
 like headers, sections, resources and more.
 .
 This is a transitional package. It can safely be removed.

Package: readpe
Replaces: pev (<< 0.82-1~)
Breaks: pev (<< 0.82-1~)
Architecture: any
Depends: libpe1t64, ${misc:Depends}, ${shlibs:Depends}
Description: command-line tools to manipulate Windows PE files
 readpe is a toolkit designed to analyze Microsoft Windows PE (Portable
 Executable) binary files. Its tools can parse and compare PE32/PE32+
 executable files (EXE, DLL, OCX, etc), and analyze them in search of
 suspicious characteristics.
 .
 It can be used to get information from those executable files, such as
 headers, sections, resources and more. It also provides tools to disassemble PE
 files and determine their security mitigations. It is useful for application
 security research, digital forensics and incident response, and malware
 analysis.
 .
 It is similar to elftools, only designed for PE files. It has more features
 than other more specific PE tools, such as icoextract or ntldd.
 .
 This package provides the ofs2rva, pedis, pehash, peldd, pepack, peres,
 pescan, pesec, pestr, readpe and rva2ofs commands.

Package: libpe1t64
Provides: ${t64:Provides}
Replaces: libpe1
Breaks: libpe1 (<< ${source:Version})
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: library to read Windows PE files
 The libpe1t64 package provides a shared library which allows reading PE 32 and
 64-bit files. Third party programs depend on this package to read internals of
 PE files.
 .
 This library is part of readpe.

Package: libpe-dev
Section: libdevel
Architecture: any
Depends: libpe1t64 (= ${binary:Version}), ${misc:Depends}
Description: library to read Windows PE files (development files)
 The libpe1t64 package provides a shared library which allows reading PE 32 and
 64-bit files. Third party programs depend on this package to read internals of
 PE files.
 .
 This library is part of readpe.
 .
 This package provides the development files for libpe1.

=== debian/tests/control ===
Depends: gzip-win32, readpe, valgrind
# autopkgtests don't work on armel due to missing valgrind, and on s390x due to
# upstream bug (endianness).
Architecture: !armel !s390x
Tests: test-runs
Restrictions: allow-stderr

## readpe 0.84

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 LIBPE_DIR = lib/libpe
 PEV_DIR = src
-VERSION = 0.82
+VERSION = 0.84
 ZIPDIR = pev-$(VERSION)-win
 ZIPFILE = $(ZIPDIR).zip

=== src/Makefile ===
--- 
+++ 
@@ -60,13 +60,6 @@
 	-D_GNU_SOURCE \
 	-DSHAREDIR="\"$(SHAREDIR)"\" \
 	-DPLUGINSDIR="\"$(pluginsdir)"\"
-
-# Some gcc/clang builds (depends on the distro) already define _FORTIFY_SOURCE internally, so we
-# only define it if it has not been already. This avoids redefinition warnings and weakening
-# those distros' hardening settings.
-ifneq ($(findstring _FORTIFY_SOURCE, $(CPPFLAGS)), _FORTIFY_SOURCE)
-        override CPPFLAGS += -D_FORTIFY_SOURCE=1
-endif
 
 ifeq ($(PLATFORM_OS), Darwin)
 	# We disable warnings for deprecated declarations since Apple deprecated OpenSSL in Mac OS X 10.7

=== lib/libpe/Makefile ===
--- 
+++ 
@@ -53,16 +53,16 @@
 	-I"./include" \
 	-fPIC \
 	-W -Wall -Wextra -pedantic -std=c99 -c
-override CPPFLAGS += -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2
+
 #override LDFLAGS += -lssl -lcrypto
-LIBS = -lssl -lcrypto
+LIBS = -lssl -lcrypto -lm
 
 # --- FIX: -fPIC is necessary to ALL shared objects! Changed above.
 #ifneq ($(PLATFORM_OS), CYGWIN)
 #	override CFLAGS += -fPIC
 #endif
 
-VERSION = 0.82
+VERSION = 0.84
 LIBNAME = libpe
 
 SRC_DIRS = $(srcdir) $(srcdir)/libfuzzy

=== src/plugins/Makefile ===
####### Compiler options

override CFLAGS += -O2 -I$(LIBPE) -I"../../include" -W -Wall -Wextra -std=c99 -pedantic -fPIC
override CPPFLAGS += -D_GNU_SOURCE

PLUGINS = csv html text xml json
VERSION = 1.0

plugins_BUILDDIR = ../$(pev_BUILDDIR)/plugins

csv_srcdir = $(CURDIR)
csv_SRCS = csv.c
csv_OBJS = $(addprefix ${plugins_BUILDDIR}/, $(addsuffix .o, $(basename ${csv_SRCS})))
csv_LIBNAME = csv_plugin

html_srcdir = $(CURDIR)
html_SRCS = html.c
html_OBJS = $(addprefix ${plugins_BUILDDIR}/, $(addsuffix .o, $(basename ${html_SRCS})))
html_LIBNAME = html_plugin

text_srcdir = $(CURDIR)
text_SRCS = text.c
text_OBJS = $(addprefix ${plugins_BUILDDIR}/, $(addsuffix .o, $(basename ${text_SRCS})))
text_LIBNAME = text_plugin

xml_srcdir = $(CURDIR)
xml_SRCS = xml.c
xml_OBJS = $(addprefix ${plugins_BUILDDIR}/, $(addsuffix .o, $(basename ${xml_SRCS})))
xml_LIBNAME = xml_plugin

json_srcdir = $(CURDIR)
json_SRCS = json.c
json_OBJS = $(addprefix ${plugins_BUILDDIR}/, $(addsuffix .o, $(basename ${json_SRCS})))
json_LIBNAME = json_plugin

####### Build rules

.PHONY: plugins

plugins: $(PLUGINS)

csv: LIBNAME = $(csv_LIBNAME)
csv: $(csv_OBJS)

html: LIBNAME = $(html_LIBNAME)
html: $(html_OBJS)

text: LIBNAME = $(text_LIBNAME)
text: $(text_OBJS)

xml: LIBNAME = $(xml_LIBNAME)
xml: $(xml_OBJS)

json: LIBNAME = $(json_LIBNAME)
json: $(json_OBJS)

$(PLUGINS):
ifeq ($(PLATFORM_OS), Linux)
	$(LINK) -shared -Wl,-soname,$(LIBNAME).so.1 $(LDFLAGS) -o ${plugins_BUILDDIR}/$(LIBNAME).so $^
else ifeq ($(PLATFORM_OS), NetBSD)
	$(LINK) -shared -Wl,-soname,$(LIBNAME).so.1 $(LDFLAGS) -o ${plugins_BUILDDIR}/$(LIBNAME).so $^
else ifeq ($(PLATFORM_OS), FreeBSD)
	$(LINK) -shared -Wl,-soname,$(LIBNAME).so.1 $(LDFLAGS) -o ${plugins_BUILDDIR}/$(LIBNAME).so $^
else ifeq ($(PLATFORM_OS), OpenBSD)
	$(LINK) -shared -Wl,-soname,$(LIBNAME).so.1 $(LDFLAGS) -o ${plugins_BUILDDIR}/$(LIBNAME).so $^
else ifeq ($(PLATFORM_OS), GNU)
	$(LINK) -shared -Wl,-soname,$(LIBNAME).so.1 $(LDFLAGS) -o ${plugins_BUILDDIR}/$(LIBNAME).so $^
else ifeq ($(PLATFORM_OS), GNU/kFreeBSD)
	$(LINK) -shared -Wl,-soname,$(LIBNAME).so.1 $(LDFLAGS) -o ${plugins_BUILDDIR}/$(LIBNAME).so $^
else ifeq ($(PLATFORM_OS), Darwin)
	$(LINK) -headerpad_max_install_names -dynamiclib \
		-undefined dynamic_lookup -fno-common \
		-install_name $(LIBNAME).$(VERSION).dylib \
		-current_version $(VERSION) -compatibility_version $(VERSION) \
		$(LDFLAGS) -o ${plugins_BUILDDIR}/$(LIBNAME).dylib $^
else ifeq ($(PLATFORM_OS), CYGWIN)
	$(LINK) -shared $(LDFLAGS) -o ${plugins_BUILDDIR}/$(LIBNAME).dll $^
endif

$(plugins_BUILDDIR)/%.o: %.c
	@$(CHK_DIR_EXISTS) $(dir $@) || $(MKDIR) $(dir $@)
	$(CC) -c $(CFLAGS) $(CPPFLAGS) -o $@ $^

clean:
	$(RM_DIR) ${plugins_BUILDDIR}

###

install: installdirs
	$(INSTALL_PROGRAM) $(INSTALL_FLAGS) -m 755 $(plugins_BUILDDIR)/$(csv_LIBNAME).* $(DESTDIR)$(pluginsdir)
	$(INSTALL_PROGRAM) $(INSTALL_FLAGS) -m 755 $(plugins_BUILDDIR)/$(html_LIBNAME).* $(DESTDIR)$(pluginsdir)
	$(INSTALL_PROGRAM) $(INSTALL_FLAGS) -m 755 $(plugins_BUILDDIR)/$(text_LIBNAME).* $(DESTDIR)$(pluginsdir)
	$(INSTALL_PROGRAM) $(INSTALL_FLAGS) -m 755 $(plugins_BUILDDIR)/$(xml_LIBNAME).* $(DESTDIR)$(pluginsdir)
	$(INSTALL_PROGRAM) $(INSTALL_FLAGS) -m 755 $(plugins_BUILDDIR)/$(json_LIBNAME).* $(DESTDIR)$(pluginsdir)

install-strip: INSTALL_FLAGS += -s
install-strip: install

installdirs:
	@$(CHK_DIR_EXISTS) $(DESTDIR)$(pluginsdir) || $(MKDIR) $(DESTDIR)$(pluginsdir)

uninstall:
	$(RM_DIR) $(DESTDIR)$(pluginsdir)

=== debian/changelog ===
readpe (0.84-2) unstable; urgency=medium

  * debian/control:
      - Bumped Standards-Version to 4.7.0.
      - Marked libpe-dev as 'Multi-Arch: same'.
  * debian/copyright: updated packaging copyright years.
  * debian/libpe1t64.lintian-overrides: not used anymore. Removed.
  * debian/tests/:
      - control: removed dependency on gzip-win32 and added dependency on
        gcc-mingw-w64-x86-64.
      - test-runs: replaced test executable by own source code compiled during
        test run.

 -- David da Silva Polverari <polverari@debian.org>  Sun, 09 Feb 2025 00:55:45 +0000

readpe (0.84-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: set 'Multi-Arch: same' in libpe1t64.
  * debian/copyright:
      - Updated maintainer email address.
      - Updated packaging copyright years.
  * debian/libpe1t64.symbols: updated.
  * debian/source/lintian-overrides: updated to override a lintian about a
    prebuilt Windows binary included in the source tarball.

 -- David da Silva Polverari <polverari@debian.org>  Mon, 18 Mar 2024 03:38:27 +0000

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: readpe
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
+Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders: David da Silva Polverari <polverari@debian.org>
 Homepage: https://github.com/mentebinaria/readpe/wiki
 Section: utils
 Priority: optional
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), dh-exec, libssl-dev
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/readpe
@@ -50,6 +49,7 @@
 Breaks: libpe1 (<< ${source:Version})
 Section: libs
 Architecture: any
+Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: library to read Windows PE files
  The libpe1t64 package provides a shared library which allows reading PE 32 and
@@ -61,6 +61,7 @@
 Package: libpe-dev
 Section: libdevel
 Architecture: any
+Multi-Arch: same
 Depends: libpe1t64 (= ${binary:Version}), ${misc:Depends}
 Description: library to read Windows PE files (development files)
  The libpe1t64 package provides a shared library which allows reading PE 32 and

## readpe 0.85

=== debian/changelog ===
readpe (0.85-1) unstable; urgency=medium

  * New upstream version 0.85.
  * debian/control:
      - Bumped Standards-Version to 4.7.2.
      - Dropped transitional 'pev' package after the release of trixie.
      - Removed obsolete Replaces/Breaks on 'pev'.
  * debian/copyright: replaced old postal address of FSF by URL.
  * debian/libpe1t64.symbols: added new symbol.

 -- David da Silva Polverari <polverari@debian.org>  Mon, 25 Aug 2025 05:33:01 +0000

## readpe 0.85.1

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 LIBPE_DIR = lib/libpe
 PEV_DIR = src
-VERSION = 0.84
-ZIPDIR = pev-$(VERSION)-win
+VERSION = 0.85
+ZIPDIR = readpe-$(VERSION)-win
 ZIPFILE = $(ZIPDIR).zip
 
 all:
@@ -18,7 +18,7 @@
 	cp $(PEV_DIR)/userdb.txt $(ZIPDIR)
 	cp lib/libpe/libpe.dll $(ZIPDIR)/
 	cp /usr/bin/cygwin1.dll $(ZIPDIR)/
-	cp /usr/bin/cygcrypto-1*.dll $(ZIPDIR)/
+	cp /usr/bin/cygcrypto-3.dll $(ZIPDIR)/
 	cp /usr/bin/cygz.dll $(ZIPDIR)/
 	cp README.md $(ZIPDIR)/
 	cp $(PEV_DIR)/build/*.exe $(ZIPDIR)/

=== src/Makefile ===
--- 
+++ 
@@ -136,7 +136,7 @@
 
 rva2ofs: $(pev_BUILDDIR)/rva2ofs.o $(pev_OBJS)
 	$(CC) $< -o $(pev_BUILDDIR)/$@ $(pev_COMMON_DEPS) $(LDFLAGS) $(CFLAGS) $(CPPFLAGS)
-	
+
 peldd: $(pev_BUILDDIR)/peldd.o $(pev_OBJS)
 	$(CC) $< -o $(pev_BUILDDIR)/$@ $(pev_COMMON_DEPS) $(LDFLAGS) $(CFLAGS) $(CPPFLAGS)

=== lib/libpe/Makefile ===
--- 
+++ 
@@ -62,7 +62,7 @@
 #	override CFLAGS += -fPIC
 #endif
 
-VERSION = 0.84
+VERSION = 0.85
 LIBNAME = libpe
 
 SRC_DIRS = $(srcdir) $(srcdir)/libfuzzy
@@ -83,7 +83,7 @@
 #
 # It makes a difference where in the command you write this option; the linker searches and processes
 # libraries and object files in the order they are specified. Thus, ‘foo.o -lz bar.o’ searches library
-# ‘z’ after file foo.o but before bar.o. If bar.o refers to functions in ‘z’, those functions 
+# ‘z’ after file foo.o but before bar.o. If bar.o refers to functions in ‘z’, those functions
 # may not be loaded.
 #
 
@@ -106,7 +106,7 @@
 	$(LINK) -shared -Wl,-soname,$(LIBNAME).so.1 $(LDFLAGS) -o $(LIBNAME).so $^ $(LIBS)
 else ifeq ($(PLATFORM_OS), Darwin)
 	$(LINK) -headerpad_max_install_names -dynamiclib \
-		-flat_namespace -install_name $(LIBNAME).$(VERSION).dylib \
+		-flat_namespace -install_name $(libdir)/$(LIBNAME).$(VERSION).dylib \
 		-current_version $(VERSION) -compatibility_version $(VERSION) \
 		$(LDFLAGS) -o $(LIBNAME).dylib $^ $(LIBS)
 else ifeq ($(PLATFORM_OS), CYGWIN)

=== src/plugins/Makefile ===
--- 
+++ 
@@ -68,10 +68,8 @@
 else ifeq ($(PLATFORM_OS), GNU/kFreeBSD)
 	$(LINK) -shared -Wl,-soname,$(LIBNAME).so.1 $(LDFLAGS) -o ${plugins_BUILDDIR}/$(LIBNAME).so $^
 else ifeq ($(PLATFORM_OS), Darwin)
-	$(LINK) -headerpad_max_install_names -dynamiclib \
+	$(LINK) -headerpad_max_install_names -bundle \
 		-undefined dynamic_lookup -fno-common \
-		-install_name $(LIBNAME).$(VERSION).dylib \
-		-current_version $(VERSION) -compatibility_version $(VERSION) \
 		$(LDFLAGS) -o ${plugins_BUILDDIR}/$(LIBNAME).dylib $^
 else ifeq ($(PLATFORM_OS), CYGWIN)
 	$(LINK) -shared $(LDFLAGS) -o ${plugins_BUILDDIR}/$(LIBNAME).dll $^

=== src/windows/Makefile ===
CFLAGS = -O2 -W -Wall -Wextra -std=c99 -pedantic
pev_BUILDDIR = ../build/

all:
	cc $(CFLAGS) -o $(pev_BUILDDIR)/cpload.exe cpload.c
clean:
	rm -f cpload.exe

=== tests/samples_src/Makefile ===
# This is probably not standardized but WorksForMe
CC = x86_64-w64-mingw32-gcc
# Very generic test file
CFLAGS += -DNDEBUG -Oz -mtune=generic -march=x86-64 -s -Wl,-s -Wl,--gc-sections

all: helloworld.exe

.PHONY: all 

helloworld: helloworld.c

%.exe: %
	mv $@ ../samples/$@

=== debian/changelog ===
readpe (0.85.1-1) unstable; urgency=medium

  * New upstream version 0.85.1.
      - Fixed reported version string only.

 -- David da Silva Polverari <polverari@debian.org>  Tue, 02 Sep 2025 23:51:51 +0000

=== debian/control ===
--- 
+++ 
@@ -4,25 +4,13 @@
 Homepage: https://github.com/mentebinaria/readpe/wiki
 Section: utils
 Priority: optional
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), dh-exec, libssl-dev
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/readpe
 Vcs-Git: https://salsa.debian.org/pkg-security-team/readpe.git
 
-Package: pev
-Depends: readpe, ${misc:Depends}
-Architecture: all
-Section: oldlibs
-Description: text-based tool to analyze PE files (transitional package)
- pev is a tool to get information of PE32/PE32+ executables (EXE, DLL, OCX etc)
- like headers, sections, resources and more.
- .
- This is a transitional package. It can safely be removed.
-
 Package: readpe
-Replaces: pev (<< 0.82-1~)
-Breaks: pev (<< 0.82-1~)
 Architecture: any
 Depends: libpe1t64, ${misc:Depends}, ${shlibs:Depends}
 Description: command-line tools to manipulate Windows PE files

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS  = hardening=+all

# pass cross tools as command variables to make
include /usr/share/dpkg/buildtools.mk
export CC

%:
	dh $@
execute_after_dh_auto_clean:
	$(RM) src/lib/libfuzzy/edit_dist.o src/lib/libfuzzy/fuzzy.o
override_dh_auto_build:
	dh_auto_build -- prefix=/usr pluginsdir=/usr/lib/pev/plugins
override_dh_auto_install:
	$(MAKE) prefix=/usr pluginsdir=/usr/lib/pev/plugins \
	    DESTDIR=$(CURDIR)/debian/tmp install

=== debian/tests/control ===
Depends: gcc-mingw-w64-x86-64, readpe, valgrind
# autopkgtests don't work on armel due to missing valgrind, and on s390x due to
# upstream bug (endianness).
Architecture: !armel !s390x
Tests: test-runs
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
    https://github.com/mentebinaria/readpe/tags \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
